(* 
 *
 * Copyright (c) 2004-2009, 
 * 
 *  Iulian Neamtiu      <neamtiu@cs.umd.edu> 
 *  Gareth Stoyle       <gareth.stoyle@cl.cam.ac.uk> 
 *
 * All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met: 
 *
 * 1. Redistributions of source code must retain the above copyright notice, 
 * this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice, 
 * this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution. 
 *
 * 3. The names of the contributors may not be used to endorse or promote 
 * products derived from this software without specific prior written 
 * permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE. 
 *
 *
 *)



(*
   C's Sizeof operator can be problematic.  Until we figure out what to do with it,
   we will pin down any type that the programmer asks for the size of.

   We think (optimistically) that positive arithmetic should be OK.  In any case,
   negation is a big NO.

*)


open Cil


(* FIXME: keep track of the current location *)

class sizeofPinDownVisitor : cilVisitor = object(self)
  inherit nopCilVisitor

  method vexpr e =
     match e with 

   
      | SizeOf t ->
          if Namedtypes.isAbstractType t then 
            begin

              (if not (Namedtypes.isExternalType t) then
                 ignore ( Updatedebug.log [Updatedebug.BTAlways] 
                         "Warning! Named type %s used in sizeof - check for compatibility with update!\n"
                         (Updatecilutil.getAbstractTypeName t) );
              );
              DoChildren
                (*Namedtypes.setTypeNonUpdatableDeepNoPtr t Cil.locUnknown "passed to sizeof(-)";*)
            end
          else
            DoChildren

      | _ -> DoChildren

end
