struct foo 
{
  int x;
};

#pragma __DSU_malloc("xmalloc")

extern void * xmalloc(int);
extern void * memset(void *s, int c, unsigned n);
extern void   free(void *);

/* 
struct foo should not be killed by the xmalloc because of the pragma,
and should not be killed by memset/free because memeset and free are 
predefined malloc-like functions

 Instead, a warning should be printed 
"Warning! Named type struct_foo used in sizeof - check for compatibility with update!"

*/
int main(int argc, char **argv)
{
  struct foo * pf;

  pf = xmalloc(sizeof(struct foo));

  memset(pf, 0, sizeof(struct foo));

  free(pf);

  return 0;
}
