/* 
 *
 * Copyright (c) 2006-2009, 
 * 
 *  Iulian Neamtiu      <neamtiu@cs.umd.edu> 
 *
 * All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met: 
 *
 * 1. Redistributions of source code must retain the above copyright notice, 
 * this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice, 
 * this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution. 
 *
 * 3. The names of the contributors may not be used to endorse or promote 
 * products derived from this software without specific prior written 
 * permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE. 
 *
 *
 */



#ifndef DSU_CONFIG_H
#define DSU_CONFIG_H

#define DSU_ENABLE_ERROR 1
/* #define DSU_ENABLE_DEBUG 1 */
/* #define DSU_ENABLE_FDEBUG 1 */

#define NOSPLIT 1

#define DSU_USE_THREADS 1

#ifdef DSU_USE_THREADS
#define LEADER_TRIES           5
#define LEADER_WAIT_USEC   10000
#define FOLLOWER_WAIT_USEC 50000

#define MAX_THREADS 100

#endif // DSU_USE_THREADS

#define USE_PATCH_METADATA 1

#define DSU_USE_VC 1

#define RUNTIME_SYSTEM_1 1  // 1. checkin
#define RUNTIME_SYSTEM_2 2  // 2. checkin, ignore vc
#define RUNTIME_SYSTEM_3 3  // 3. DSU | checkin = upd point
#define RUNTIME_SYSTEM_4 4  // 4. no lock/unlock restrict mutex unless update
#define RUNTIME_SYSTEM_5 5  // 5. barrier sync, check delta
#define RUNTIME_SYSTEM_6 6  // 6. barrier sync, check delta+VC
#define RUNTIME_SYSTEM_7 7  // 7. like 3, but sem. upd., not checkin trigger updates
#define RUNTIME_SYSTEM_8 8  // 8. like 6, but sem. upd., not checkin trigger updates


#if   defined(RS1)
#define RUNTIME_SYSTEM RUNTIME_SYSTEM_1
#elif defined(RS2)
#define RUNTIME_SYSTEM RUNTIME_SYSTEM_2
#elif defined(RS3)
#define RUNTIME_SYSTEM RUNTIME_SYSTEM_3
#elif defined(RS4)
#define RUNTIME_SYSTEM RUNTIME_SYSTEM_4
#elif defined(RS5)
#define RUNTIME_SYSTEM RUNTIME_SYSTEM_5
#elif defined(RS6)
#define RUNTIME_SYSTEM RUNTIME_SYSTEM_6
#elif defined(RS7)
#define RUNTIME_SYSTEM RUNTIME_SYSTEM_7
#elif defined(RS8)
#define RUNTIME_SYSTEM RUNTIME_SYSTEM_8
#else
#error "You must select a runtime system by defining #RS_n"
#endif // RS_n

#endif  //DSU_CONFIG_H
