/* Map implementation. Stores (char * key, void * value) pairs  */

#include <string>
#include <map>

using namespace std;

typedef map<string,void *> OurMap;

void * cppCreateMap()
{
  OurMap * p = new OurMap;
  return p;
}

void cppAdd(void * mapp, const char * key, void * value)
{
  OurMap * ourmap = (OurMap *)mapp;

  (*ourmap)[key] = value;
}

void * cppFind(void * mapp, const char * key)
{
  OurMap * ourmap = (OurMap *)mapp;
  OurMap::iterator pos = (*ourmap).find(key);

  if ( pos  ==  (*ourmap).end() )
    return NULL;
  else
    return pos->second;
}

void cppRemove(void * mapp, const char * key)
{
  OurMap * ourmap = (OurMap *)mapp;

  (*ourmap).erase(key);
}

void cppDeleteMap(void * mapp)
{
  OurMap * ourmap = (OurMap *)mapp;

  delete ourmap;
}

extern "C" void * mCreateMap() 
{ return cppCreateMap(); }

extern "C" void   mAdd(void * mapp, const char * key, void * value)
{ cppAdd(mapp, key, value); }

extern "C" void * mFind(void * mapp, const char * key)
{ return cppFind(mapp, key); }

extern "C" void   mRemove(void * mapp, const char * key)
{ return cppRemove(mapp, key); }

extern "C" void   mDeleteMap(void * mapp)
{ return cppDeleteMap(mapp); }
