#include <stdlib.h>
#include <search.h>
#include "mapp.h"

extern char **split(char *string, char *delim);

static void * capability_hash = NULL;
static int q_reached;

void quies_init()
{
  capability_hash = mCreateMap();
}

static void quies_op(char * capability, int op)
{
  char * delim = " ";
  char ** type_names;
  int i;

  /* this makes deep copies */
  type_names = split(capability, delim);

  for(i = 0; type_names[i]; i++)
    {
      unsigned int * type_count = mFind(capability_hash, type_names[i]);
      if (type_count == NULL) // not present, add it
        {
          mAdd(capability_hash, type_names[i], calloc(1, sizeof(unsigned int)));
          type_count = mFind(capability_hash, type_names[i]);
        }

      (*type_count)+= op;
    }
}


void quies_check_in(char * capability)
{
  quies_op(capability, +1);
}

void quies_check_out(char * capability)
{
  quies_op(capability, -1);
}

static void check_one_node(const void *nodep, const VISIT which, const int depth)
{
  ENTRY * e = (ENTRY *)nodep;

  if (*((unsigned int *)e->data) != 0)
    q_reached = 0;
}

int quies_reached()
{
  q_reached = 1;
  twalk(((struct tree_root *)capability_hash)->rootp, check_one_node);
  
  return (q_reached == 1);
}
