/* 
 *
 * Copyright (c) 2005-2009, 
 * 
 *  Iulian Neamtiu      <neamtiu@cs.umd.edu> 
 *
 * All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met: 
 *
 * 1. Redistributions of source code must retain the above copyright notice, 
 * this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice, 
 * this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution. 
 *
 * 3. The names of the contributors may not be used to endorse or promote 
 * products derived from this software without specific prior written 
 * permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE. 
 *
 *
 */



#ifndef PMETA_H
#define PMETA_H

/* Patch metadata interface. 
 */

/* Create metadata for a new version */
void new_metadata(char * changed_types, char * changed_defs, int version);

/* Is this update allowed ? In other words, are modified_functions and forbidden_functions disjoint */
#ifndef DSU_USE_VC
int is_allowed_update(char * capability);
#endif

/* split string into tokens, return token array */
char **split(const char *string, const char *delim);

/* free token array allocated by split */
void free_tokens(char **tokens);

int disjoint(char **tokens, char ** forbidden_tokens);

void print_string_array(char ** array);

char ** get_current_changed_types(); 
char ** get_current_changed_defs(); 

/* Name of the global variables containing the metadata (should be found in the dynamic patch file).
 * Note: if you change these, then change 
   Updateconfig.[type|def]_metadata_var_name/type too!!!
 */
char * type_metadata_var_name;
char * def_metadata_var_name;
#endif //PMETA_H
